package test;

import com.poscoict.glueframework.biz.control.GlueBizControlConstants;
import com.poscoict.glueframework.biz.control.GlueBizController;
import com.poscoict.glueframework.biz.control.GlueBizProvider;
import com.poscoict.glueframework.context.GlueContext;
import com.poscoict.glueframework.context.GlueDefaultContext;
import sample.vo.EmpVO;

import java.io.File;
import java.io.IOException;
import java.util.List;

public class Test_sample03 {
    public static void main(String[] args) throws IOException {
        File baseDir = new File("." + File.separator + "etc");
        System.setProperty("CONFIG_PATH", baseDir.getCanonicalPath());
        System.out.println("=================================== 시작 ");
        GlueBizController controller = GlueBizProvider.getController();
        System.out.println("=================================== bean 생성완료");

        GlueContext ctx = new GlueDefaultContext();
        ctx.put(GlueBizControlConstants.SERVICE_NAME, "sample03-service");
        System.out.println("=================================== GlueContext 생성완료");
        controller.doAction(ctx);
        System.out.println("=================================== GlueService 실행완료");
        System.out.println("=================================== 종료 ");

        ctx = new GlueDefaultContext();
        ctx.put(GlueBizControlConstants.SERVICE_NAME, "sample03-service");
        ctx.put("find", "event");
        ctx.put("deptno", "30");
        System.out.println("=================================== GlueContext 생성완료 ( 2차 )");
        controller.doAction(ctx);
        System.out.println("=================================== GlueService 실행완료 ( 2차 )");
        for (EmpVO emp : (List<EmpVO>) ctx.get("EmpList")) {
            System.out.println(emp.getEmpno() + "\t" + emp.getEname() + "\t" + emp.getDeptno() + "\t" + emp.getJob() + "\t" + emp.getSal());
        }
        System.out.println("=================================== 종료 ");

        ctx = new GlueDefaultContext();
        ctx.put(GlueBizControlConstants.SERVICE_NAME, "sample03-service");
        ctx.put("insert", "event");
        ctx.put("empno_insert", "1234");
        ctx.put("ename_insert", "test");
        ctx.put("sal_insert", "2000");
        ctx.put("deptno_insert", "30");
        ctx.put("deptno", "30");
        System.out.println("=================================== GlueContext 생성완료 ( 3차 )");
        controller.doAction(ctx);
        System.out.println("=================================== GlueService 실행완료 ( 3차 )");
        for (EmpVO emp : (List<EmpVO>) ctx.get("EmpList")) {
            System.out.println(emp.getEmpno() + "\t" + emp.getEname() + "\t" + emp.getDeptno() + "\t" + emp.getJob() + "\t" + emp.getSal());
        }
        System.out.println("=================================== 종료 ");

        ctx = new GlueDefaultContext();
        ctx.put(GlueBizControlConstants.SERVICE_NAME, "sample03-service");
        ctx.put("update", "event");
        ctx.put("SAL", "3000");
        ctx.put("ENAME", "Test");
        ctx.put("EMPNO", "1234");
        ctx.put("deptno", "30");
        System.out.println("=================================== GlueContext 생성완료 ( 4차 )");
        controller.doAction(ctx);
        System.out.println("=================================== GlueService 실행완료 ( 4차 )");
        for (EmpVO emp : (List<EmpVO>) ctx.get("EmpList")) {
            System.out.println(emp.getEmpno() + "\t" + emp.getEname() + "\t" + emp.getDeptno() + "\t" + emp.getJob() + "\t" + emp.getSal());
        }
        System.out.println("=================================== 종료 ");

        ctx = new GlueDefaultContext();
        ctx.put(GlueBizControlConstants.SERVICE_NAME, "sample03-service");
        ctx.put("delete", "event");
        ctx.put("EMPNO", "1234");
        ctx.put("deptno", "30");
        System.out.println("=================================== GlueContext 생성완료 ( 5차 )");
        controller.doAction(ctx);
        System.out.println("=================================== GlueService 실행완료 ( 5차 )");
        for (EmpVO emp : (List<EmpVO>) ctx.get("EmpList")) {
            System.out.println(emp.getEmpno() + "\t" + emp.getEname() + "\t" + emp.getDeptno() + "\t" + emp.getJob() + "\t" + emp.getSal());
        }
        System.out.println("=================================== 종료 ");
    }
}